; Program that calculates the area of the shadow of a triangle on the ZX plane,
; Autor:  Jorge Aguero
; Fecha: 03/07/2008
; equations: x=2t+c; y=3t+a; z=4t+b

.386
.MODEL FLAT

ExitProcess PROTO NEAR32 stdcall, dwExitCode:DWORD

INCLUDE io.h						; Header for the input/output file

cr      EQU     0dh     			
Lf      EQU     0ah     			

.STACK 4096							

.DATA								

raiz	DWORD	0
divisor	DWORD	1

x1		DWORD 	?
x2 		DWORD 	?
x3 		DWORD 	?
y1 		DWORD 	?
y2 		DWORD 	?
y3 		DWORD 	?
z1 		DWORD 	?
z2 		DWORD 	?
z3 		DWORD 	?

x0 		DWORD 	0
y0 		DWORD 	1000
z0 		DWORD 	0

x1n		DWORD	40 DUP(?)
z1n		DWORD	40 DUP(?)
x2n		DWORD	40 DUP(?)
z2n		DWORD	40 DUP(?)
x3n		DWORD	40 DUP(?)
z3n		DWORD	40 DUP(?)

diez	BYTE	10
dos		BYTE	2

a1		DWORD   40 DUP (?)
a2		DWORD   40 DUP (?)
a3		DWORD   40 DUP (?)

b1		DWORD   40 DUP (?)
b2		DWORD   40 DUP (?)
b3		DWORD   40 DUP (?)

c1		DWORD   40 DUP (?)
c2		DWORD   40 DUP (?)
c3		DWORD   40 DUP (?)

t1		DWORD   40 DUP (?)
t2		DWORD   40 DUP (?)
t3		DWORD   40 DUP (?)

string	BYTE    40 DUP (?)

prompt1 BYTE 	"Enter the X of the first point of the triangle ", 0
prompt2 BYTE 	"Enter the Y of the first point of the triangle ", 0
prompt3	BYTE 	"Enter the Z of the first point of the triangle ", 0

prompt4 BYTE 	"Enter the X of the first point of the triangle ", 0
prompt5 BYTE 	"Enter the Y of the second point of the triangle ", 0
prompt6	BYTE 	"Enter the Z of the third point of the triangle ", 0

prompt7 BYTE 	"Enter the X of the first point of the triangle ", 0
prompt8 BYTE 	"Enter the Y of the second point of the triangle ", 0
prompt9	BYTE 	"Enter the Z of the third point of the triangle ", 0

label2	BYTE    cr, Lf, "La sombra es "
area	BYTE    11 DUP (?)
		BYTE    cr, Lf, 0

label1	BYTE	"+===============================================+"
		BYTE	"												 "
		BYTE	"												 "
		BYTE	"				Welcome							 "
		BYTE	"												 "
		BYTE	"												 "
		BYTE	"+===============================================+", cr , lf, lf
		


.CODE								

_start:	

	output 	label1					; shows the Welcome tag

;=====================  Data Input  ============================
	output 	prompt1					; asks for the first x
	input 	string,	20				
	atod 	string					
	mov		x1,		eax				

	output 	prompt2					; asks the first y
	input 	string,	20		
	atod 	string			
	mov		y1,		eax		

	output 	prompt3					; asks the first z
	input 	string,	20		
	atod 	string			
	mov		z1,		eax		


	output 	prompt4					; the same for the second point
	input 	string,	20		 
	atod 	string			
	mov	x2,	eax		

	output 	prompt5			
	input 	string,	20		
	atod 	string			
	mov		y2,		eax		

	output 	prompt6			
	input 	string,	20		
	atod 	string			
	mov		z2,		eax		


	output 	prompt7					; and the third one
	input 	string,	20		 
	atod 	string			 
	mov		x3,		eax		 

	output 	prompt8			
	input 	string,	20		
	atod 	string			
	mov		y3,		eax		

	output 	prompt9			
	input 	string,	20		
	atod 	string			
	mov		z3,		eax
	
;=======================================================

	
	cmp		y1,		0				; check to see if the first point is on the shadow plane
	jz		_punto1EnPlano			; if it does I jump here
		
	mov		eax,	x0				 
	sub		eax,	x1				
	mov		a1,		eax				

	mov		eax,	y0				
	sub		eax,	y1		
	mov		b1,		eax		

	mov		eax,	z0				
	sub		eax,	z1		
	mov		c1,		eax
	
;this code helps me find the t in x=2t+c when y=0 (the zx plane)
	cdq								
	mov		eax,	y1				
	neg		eax						
	mov		ebx,	b1				
	mov		divisor,ebx	
	nop
	idiv	divisor					
	mov		t1,		eax				
	cmp		edx,	0				
	jz		_calculoPunto1	
	mov		eax,	edx	
	mul		diez					
	cdq
	nop								
	idiv	divisor					
	cmp		eax,	4				
	jng		_calculoPunto1						
	inc		t1						
	
with t I find the x and z coordinates of the first point:
	mov		eax,	a1				
	mul		t1						
	
	add		eax,	x1				
	
	mov		x1n,	eax				
	
	mov		eax,	c1				
	mul		t1						
	
	add		eax,	z1				
	
	mov		z1n,	eax				

	jmp _punto2		
	
_punto1EnPlano:
; this code is executed if y1 is 0
	mov		eax,		x1			
	mov		x1n,		eax			
	mov		eax,		z1
	mov		z1n,		eax


_punto2:

	cmp		y2,		0				; Check to see if second point is on the zx plane
	jz		_punto2EnPlano			
	
	mov		eax,	x0					
	sub		eax,	x2		
	mov		a2,		eax		

	mov		eax,	y0		
	sub		eax,	y2		
	mov		b2,		eax		

	mov		eax,	z0		
	sub		eax,	z2		
	mov		c2,		eax
	
; Code to find the second line's t 
	cdq								
	mov		eax,	y2				
	neg		eax						
	mov		ebx,	b2				
	mov		divisor,ebx	
	nop
	idiv	divisor					
	mov		t2,		eax				
	cmp		edx,	0				
	jz		_calculoPunto2	
	mov		eax,	edx	
	mul		diez					
	cdq		
	nop						
	idiv	divisor					
	cmp		eax,	4				
	jng		_calculoPunto2						
	inc		t2						
	
; once I have t, I calculate the second point's z and x coordinates
_calculoPunto2:
	mov		eax,	a2				
	mul		t2						
	
	add		eax,	x2				
	
	mov		x2n,	eax				
	
	mov		eax,	c2				
	mul		t2						
	
	add		eax,	z2				
	
	mov		z2n,	eax				
	
	jmp	_punto3
	
_punto2EnPlano:
	mov		eax,		x2			
	mov		x2n,		eax			
	mov		eax,		z2
	mov		z2n,		eax
			
_punto3:
; the same for the third point
	cmp		y3,		0				
	jz		_punto3EnPlano			
	
	mov		eax,	x0		
	sub		eax,	x3		
	mov		a3,		eax		

	mov		eax,	y0		
	sub		eax,	y3		
	mov		b3,		eax		

	mov		eax,	z0		
	sub		eax,	z3		
	mov		c3,		eax
	
	cdq								
	mov		eax,	y3				
	neg		eax						
	mov		ebx,	b3				
	mov		divisor,ebx
	nop	
	idiv	divisor			
	mov		t3,		eax		
	cmp		edx,	0		
	jz		_calculoPunto3
	mov		eax,	edx	
	mul		diez			
	cdq			
	nop					
	idiv	divisor					
	cmp		eax,	4				
	jng		_calculoPunto3
	inc		t3						
	
	
_calculoPunto3:
	mov		eax,	a3				
	mul		t3						
	
	add		eax,	x3				
	
	mov		x3n,	eax				
	
	mov		eax,	c3				
	mul		t3						
	
	add		eax,	z3				
	
	mov		z3n,	eax				
	
	jmp		_siguiente
	
_punto3EnPlano:
	mov		eax,		x3			
	mov		x3n,		eax			
	mov		eax,		z3
	mov		z3n,		eax
			

;===============  With the coordinates for the shadow, I find its Area  ==============
_siguiente:
; I choose a side for it to be the base (the first and second points), and find its size
	mov		eax,	x2n				
	sub		eax,	x1n				
	mul		eax						
	push	eax						
	
	mov		eax,	z2n				
	sub		eax,	z1n
	mul		eax
	
	mov		ebx,	eax				
	pop		eax						
	
	add		eax,	ebx				
	
	;************I Use the FPU To find the square root***********
	fninit							; inicializo el coprocesador		
	mov		raiz,	eax				; copio la raiz a una variable dq
	fld		raiz					; cargo la variable a ST(0)	
	FSQRT							; saco la raiz cuadrada y se guarda en ST(0)
	fstp	raiz					; y popeo el resultado a la variable raiz	
	;************** ***************************			
	
; I find the incline of the line
	mov		eax,	x2n				
	sub		eax,	x1n				
	mov		ebx,	eax				
	
	mov		eax,	z2n				
	sub		eax,	z1n				
	
	cdq								
	mov		divisor,ebx	
	nop
	idiv	divisor					
	
	cmp		eax,	4				
	jng		_loQueSigue
	inc		eax						
	
	push	eax						
	
_loQueSigue:
;	I find b based on the y=mx-b equation
	neg		x1n						
	mul		x1n						
	add		eax,	z1n				
	mov		ebx,	eax				
	
;I find the altitud of the triangle
	pop		eax						
	push	eax						
	add		eax,	eax				
	inc		eax						
	
	;************ FPU ***********	
	mov		raiz,	eax				
	fld		raiz					
	FSQRT							
	fstp	raiz					
	;************** ***************************	
	
; I finish findind the ecuation for the line
	pop		eax						
	mul		x3n						
	sub		eax,	z3n				
	add		eax,	ebx				
	
	cdq
	div		raiz					
	
	cmp		eax,	4				
	jng		_area
	inc		eax						
	
; I find the shadow's area

_area:
	
	mov		ebx,	eax				
	pop		eax						
	mul		ebx						
	div		dos						
	
; I show the Area to the user
	
	dtoa	area,	eax
	output	label2
	
	;===================  Fin  ==================================
		
	INVOKE  ExitProcess, 0  		

PUBLIC _start                   	

END                             	